from abc import ABC, abstractmethod
from pathlib import Path

class RemoterInterface(ABC):

    @abstractmethod
    def connect(self):
        pass

    @abstractmethod
    def is_connected(self) -> bool:
        pass

    @abstractmethod
    def disconnect(self):
        pass

    @abstractmethod
    def download(self, src_fname:Path = None, dst_fname:Path = None):
        pass

    @abstractmethod
    def upload(self, src_fname:Path = None, dst_fname:Path = None):
        pass

    @abstractmethod
    def exists(self, path: Path) -> bool:
        pass

